/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

/**
 * An addition to a field index.
 */
class IxAdd extends IxPatch {
    
    boolean i_keepRemoved;

    IxAdd(IxFieldTransaction a_ft, int a_parentID, Object a_value) {
        super(a_ft, a_parentID, a_value);
    }
    
    Tree addToCandidatesTree(Tree a_tree, QCandidates a_candidates, int[] a_lowerAndUpperMatch) {
        QCandidate candidate = new QCandidate(a_candidates, i_parentID, true);
        if (a_tree == null) {
            return candidate;
        }
        a_tree = a_tree.add(candidate);
        return a_tree;
    }

    void write(YapDataType a_handler, YapWriter a_writer) {
        a_writer.i_offset = 0;
        a_handler.writeIndexEntry(a_writer, i_value);
        a_writer.writeInt(i_parentID);
        a_writer.write();
        a_writer.setAddress(a_writer.getAddress() + a_writer.getLength());
    }
    
    void beginMerge(){
        super.beginMerge();
        handler().prepareComparison( handler().indexObject(trans(), i_value));
    }
    
    public String toString(){
        String str = "IxAdd "  + i_parentID + "\n " + handler().indexObject(trans(), i_value);
        return str;
    }
    

}
