/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

final class MCreateClass extends MsgD {
    final boolean processMessageAtServer(YapSocket sock) {
        Class clazz = null;
        YapStream stream = getStream();
        Transaction trans = stream.getSystemTransaction();
        YapWriter returnBytes = new YapWriter(trans, 0);
        try {
            clazz = Db4o.classForName(stream, this.readString());
        } catch (Exception e) {
        }
        if (clazz != null) {
            synchronized (stream.i_lock) {
                try {
                    YapClass yapClass = stream.getYapClass(clazz, true);
                    if (yapClass != null) {
                        yapClass.setStateDirty();
                        yapClass.write(stream, trans);
                        trans.commit();
                        returnBytes = stream.readWriterByID(trans, yapClass.getID());
                    } else {
                        // TODO: handling, if the class can't be created 
                    }
                } catch (Throwable t) {
                    if (Deploy.debug) {
                        System.out.println("MsgD.CreateClass failed");
                    }
                }
            }
        }
        //		TODO: now what is written here, if the class can't be created?
        Msg.OBJECT_TO_CLIENT.getWriter(returnBytes).write(stream, sock);
        return true;
    }
}
