/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

final class MGetInternalIDs extends MsgD {
	final boolean processMessageAtServer(YapSocket sock) {
		YapWriter bytes = this.getByteLoad();
		long[] ids;
		YapStream stream = getStream();
		synchronized (stream.i_lock) {
			try {
				ids = stream.getYapClass(bytes.readInt()).getIDs(getTransaction());
			} catch (Exception e) {
				ids = new long[0];
			}
		}
		int size = ids.length;
		MsgD message = Msg.ID_LIST.getWriterForLength(getTransaction(), YapConst.YAPID_LENGTH * (size + 1));
		YapWriter writer = message.getPayLoad();
		writer.writeInt(size);
		for (int i = 0; i < size; i++) {
			writer.writeInt((int) ids[i]);
		}
		message.write(stream, sock);
		return true;
	}
}