/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

final class MReadMultipleObjects extends MsgD {
	final boolean processMessageAtServer(YapSocket sock) {

		int size = readInt();
		MsgD[] ret = new MsgD[size];
		int length = (1 + size) * YapConst.YAPINT_LENGTH;
		YapStream stream = getStream();

		YapWriter bytes = null;		
		synchronized (stream.i_lock) {
			for (int i = 0; i < size; i++) {
				int id = this.payLoad.readInt();
				try {
					bytes =
						stream.readWriterByID(
							getTransaction(),
							id);
				} catch (Exception e) {
					bytes = null;
				}
				if(bytes != null){
					try{
						YapClassAny.appendEmbedded(bytes);
					}catch(Exception e){
						if(Debug.atHome){
							e.printStackTrace();
						}
					}
					ret[i] = Msg.OBJECT_TO_CLIENT.getWriter(bytes);
					length += ret[i].payLoad.getLength();
				}
			}
		}
		
		MsgD multibytes = Msg.READ_MULTIPLE_OBJECTS.getWriterForLength(getTransaction(), length);
		multibytes.writeInt(size);
		for (int i = 0; i < size; i++) {
			if(ret[i] == null){
				multibytes.writeInt(0);
			}else{
				multibytes.writeInt(ret[i].payLoad.getLength());
				multibytes.payLoad.append(ret[i].payLoad.i_bytes);
			}
		}
		multibytes.write(stream, sock);
		return true;
	}
}