/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

final class MReadObject extends MsgD {
	final boolean processMessageAtServer(YapSocket sock) {
		YapWriter bytes = null;

		// readObjectByID may fail in certain cases
		// we should look for the cause at some time in the future
		
		YapStream stream = getStream();

		synchronized (stream.i_lock) {
			try {
				bytes = stream.readWriterByID(this.getTransaction(), this.payLoad.readInt());
			} catch (Exception e) {
				bytes = null;
				if (Deploy.debug) {
					System.out.println("MsD.ReadObject:: readObjectByID failed");
				}
			}
		}
		if (bytes == null) {
			bytes = new YapWriter(this.getTransaction(), 0, 0);
		}
		Msg.OBJECT_TO_CLIENT.getWriter(bytes).write(stream, sock);
		return true;
	}
}