/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

import com.db4o.ext.*;

abstract class MsgBlob extends MsgD {

    BlobImpl i_blob;
    int i_currentByte;
    int i_length;

    double getStatus() {
        if (i_length != 0) {
            return (double) i_currentByte / (double) i_length;
        }
        return Status.ERROR;
    }

    abstract void processClient(YapSocket sock);

    BlobImpl serverGetBlobImpl() {
        BlobImpl blobImpl = null;
        int id = payLoad.readInt();
        YapStream stream = getStream();
        synchronized (stream.i_lock) {
            blobImpl = (BlobImpl) stream.getByID1(getTransaction(), id);
            stream.activate1(getTransaction(), blobImpl, 3);
        }
        return blobImpl;
    }

}
