/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

class Null implements YapComparable{
    
    public int compareTo(Object a_obj) {
        if(a_obj == null) {
            return 0;
        }
        return -1;
    }
    
	public boolean equals(Object obj){
		return obj == null;
	}
	
	public boolean isEqual(Object obj) {
		return obj == null;
	}

	public boolean isGreater(Object obj) {
		return false;
	}

	public boolean isSmaller(Object obj) {
		return false;
	}

	public YapComparable prepareComparison(Object obj) {
		// do nothing
		return this;
	}
	
	static final YapComparable INSTANCE = new Null();

}

