/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

/** QE stands for QueryEvaluator */
public class QE
{
    
	static final QE DEFAULT = new QE();
	
	QE add(QE evaluator){
		return evaluator;
	}
	
	boolean identity(){
		return false;
	}
	
	boolean evaluate(QConObject a_constraint, QCandidate a_candidate, Object a_value){
		if(a_value == null){
			return a_constraint.getComparator(a_candidate) instanceof Null;
		}
		return a_constraint.getComparator(a_candidate).isEqual(a_value);
	}
	
	public boolean equals(Object obj){
		return obj.getClass() == this.getClass();
	}
	
	// overridden in QENot 
	boolean not(boolean res){
		return res;
	}
	
	/**
	 * Specifies which part of the index to take.
	 * Array elements:
	 * [0] - smaller
	 * [1] - equal
	 * [2] - greater
	 * [3] - nulls
	 * 
	 * 
	 * @param bits
	 */
	void indexBitMap(boolean[] bits){
	    bits[1] = true;
	}
	
	boolean supportsIndex(){
	    return true;
	}
	
}
