/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

class QPending extends Tree{
	
	final QConJoin			i_join;
	QCon 					i_constraint;
	
	int 					i_result;

	// Constants, so QConJoin.evaluatePending is made easy:
	static final int FALSE = -4;
	static final int BOTH = 1;
	static final int TRUE = 2;
	
	QPending(QConJoin a_join, QCon a_constraint, boolean a_firstResult){
		i_join = a_join;
		i_constraint = a_constraint;
		
		i_result = a_firstResult ? TRUE : FALSE;
	}
	
	int compare(Tree a_to) {
		return i_constraint.i_id - ((QPending)a_to).i_constraint.i_id;
	}

	void changeConstraint(){
		i_constraint = i_join.getOtherConstraint(i_constraint);
	}
}

