/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

final class Slot implements ReadWriteable{
	int i_address;
	int i_length;
	int i_references;
	
	Slot(int address, int length){
		i_address = address;
		i_length = length;
	}
	
	public int byteCount(){
		return YapConst.YAPINT_LENGTH * 2;
	}
	
	public void write(YapWriter a_bytes){
		a_bytes.writeInt(i_address);
		a_bytes.writeInt(i_length);
	}
	
	public Object read(YapReader a_bytes){
		int address = a_bytes.readInt();
		int length = a_bytes.readInt();
		return new Slot(address, length);
	}
}
