/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

class TreeIntObject extends TreeInt{
	
	Object i_object;
	
	TreeIntObject(int a_key){
		super(a_key);
	}
	
	TreeIntObject(int a_key, Object a_object){
		super(a_key);
		i_object = a_object;
	}
	
	public Object read(YapReader a_bytes){
		int key = a_bytes.readInt();
		Object obj = null;
		if(i_object instanceof Tree){
			obj = new TreeReader(a_bytes, (Tree)i_object).read();
		}else{
			obj = ((Readable)i_object).read(a_bytes);	
		}
		return new TreeIntObject(key, obj);
	}
	
	public void write(YapWriter a_writer){
		a_writer.writeInt(i_key);
		if(i_object == null){
			a_writer.writeInt(0);
		}else{
			if(i_object instanceof Tree){
				Tree.write(a_writer, (Tree)i_object);
			}else{
				((ReadWriteable)i_object).write(a_writer);
			}
		}
	}
	
	int ownLength(){
		if(i_object == null){
			return YapConst.YAPINT_LENGTH * 2;
		}else{
			return YapConst.YAPINT_LENGTH + ((Readable)i_object).byteCount();
		}
	}
	
	boolean variableLength(){
		return true;
	}

}
