/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

interface YapDataType extends YapComparable
{
	
	void appendEmbedded3(YapWriter a_bytes);
	
	boolean canHold(Class a_class);
	
	void cascadeActivation(Transaction a_trans, Object a_object, int a_depth, boolean a_activate);
	
	// special construct for deriving from simple types
	void copyValue(Object a_from, Object a_to);
	
	void deleteEmbedded(YapWriter a_bytes);
	
	int getID();
	
	Class getJavaClass();
	
	Class getPrimitiveJavaClass();
	
	boolean equals(YapDataType a_dataType); // needed for YapField.equals
	
	Object indexEntry(Object a_object);
	
	Object indexObject(Transaction a_trans, Object a_object);
	
	int linkLength();
	
	void prepareLastIoComparison(Transaction a_trans, Object obj);
	
	Object read(YapWriter writer) throws CorruptionException;
	
	Object readIndexObject(YapWriter writer) throws CorruptionException;
	
	Object readQuery(Transaction trans, YapReader reader, boolean toArray) throws CorruptionException;
	
	boolean supportsIndex();
	
	void writeNew(Object a_object, YapWriter a_bytes);
	
	public int getType ();
	
	YapClass getYapClass(YapStream a_stream);
	
	void readCandidates(YapReader a_bytes, QCandidates a_candidates);
	
	Object readIndexEntry(YapReader a_reader) ;
	
	YapDataType readArrayWrapper(Transaction a_trans, YapReader[] a_bytes);
	
	void writeIndexEntry(YapWriter a_writer, Object a_object);

	
}
