/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o;

/**
 * 
 */
class YapFieldVersion extends YapFieldVirtual {

    YapFieldVersion() {
        super();
        i_name = PREFIX + "version";
    }
    
    void addFieldIndex(YapWriter a_writer, boolean a_new) {
        YLong.writeLong(((YapFile) a_writer.getStream()).i_bootRecord.version(), a_writer);
    }
    
    void instantiate1(Transaction a_trans, YapObject a_yapObject, YapReader a_bytes) {
        a_yapObject.i_virtualAttributes.i_version = YLong.readLong(a_bytes);
    }

    void marshall1(YapObject a_yapObject, YapWriter a_bytes, boolean a_migrating, boolean a_new) {
        if (!a_migrating) {
            YapStream stream = a_bytes.getStream().i_parent;
            if (stream instanceof YapFile
                && ((YapFile) stream).i_bootRecord != null) {
                a_yapObject.i_virtualAttributes.i_version = ((YapFile) stream).i_bootRecord.version();
            }
        }
        if(a_yapObject.i_virtualAttributes == null){
            YLong.writeLong(0, a_bytes);
        }else{
            YLong.writeLong(a_yapObject.i_virtualAttributes.i_version, a_bytes);
        }
    }

    public int linkLength() {
        return YapConst.YAPLONG_LENGTH;
    }

}