/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.config;

import com.db4o.ObjectContainer;
import java.util.*;

public class THashtable implements ObjectTranslator
{
	public Object onStore(ObjectContainer con, Object object){
		Hashtable ht = (Hashtable)object;
		Entry[] entries = new Entry[ht.size()];
		Enumeration enum = ht.keys();
		int i = 0;
		while(enum.hasMoreElements()){
			entries[i] = new Entry();
			entries[i].key = enum.nextElement();
			entries[i].value = ht.get(entries[i].key);
			i++;
		}
		return entries;
	}

	public void onActivate(ObjectContainer con, Object object, Object members){
		Hashtable ht = (Hashtable)object;
		ht.clear();
		if(members != null){
			Entry[] entries = (Entry[]) members;
			for(int i = 0; i < entries.length; i++){
				if(entries[i].key != null && entries[i].value != null){
					ht.put(entries[i].key,entries[i].value);
				}
			}
		}
	}

	public Class storedClass(){
		return Entry[].class;
	}
}
