/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.config;

import com.db4o.ObjectContainer;
import java.util.*;

public class TTreeSet implements ObjectConstructor
{
	public Object onStore(ObjectContainer con, Object object){
		return ((TreeSet)object).comparator();
	}

	public void onActivate(ObjectContainer con, Object object, Object members){
		// do nothing
	}

	public Object onInstantiate(ObjectContainer container, Object storedObject){
		try{
			Comparator comp = (Comparator)storedObject;
			if(comp != null){
				return new TreeSet(comp);
			}
		}catch(Exception e){}
		return new TreeSet();
	}

	public Class storedClass(){
		return Object.class;
	}
}
