/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.ext;

import com.db4o.*;

/**
 * extended factory class with static methods to open special db4o sessions.
 */
public final class ExtDb4o extends Db4o {
   /**
     * opens an {@link ObjectContainer} for in-memory use .
	 * <br><br>In-memory ObjectContainers are useful for maximum performance
	 * on small databases, for swapping objects or for storing db4o format data
	 * to other media or other databases.<br><br>Be aware of the danger of running
	 * into OutOfMemory problems or complete loss of all data, in case of hardware
	 * or JVM failures.<br><br>
     * @param memoryFile a <a href="MemoryFile.html"><code>MemoryFile</code></a> 
     * to store the raw byte data.
	 * @return an open <a href="../ObjectContainer.html"><code>ObjectContainer</code></a>
     * @see <a href="MemoryFile.html"><code>MemoryFile</code></a>
	 */
	public static final ObjectContainer openMemoryFile(MemoryFile memoryFile) {
		return openMemoryFile1(memoryFile);
	}
}
