/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.ext;

import com.db4o.*;

/**
 * extended functionality for the
 * <a href="../ObjectSet.html"><code>ObjectSet</code></a> interface.
 * <br><br>Every db4o <a href="../ObjectSet.html"><code>ObjectSet</code></a>
 * always is an ExtObjectSet so a cast is possible.<br><br>
 * <a href="../ObjectSet.html#ext()"><code>ObjectSet.ext()</code></a>
 * is a convenient method to perform the cast.<br><br>
 * The ObjectSet functionality is split to two interfaces to allow newcomers to
 * focus on the essential methods.
 */
public interface ExtObjectSet extends ObjectSet {
	
	/**
	 * returns an array of internal IDs that correspond to the contained objects.
	 * <br><br>
	 * @see <a href="ExtObjectContainer.html#getID(java.lang.Object)">
	 * <code>ExtObjectContainer.getID()</code></a>
	 * @see <a href="ExtObjectContainer.html#getByID(long)">
	 * <code>ExtObjectContainer.getByID()</code></a>
	 */
	public long[] getIDs();
	
	
}
