/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.ext;

import com.db4o.*;


/**
 * this Exception is thrown, if objects can not be stored and if
 * db4o is configured to throw Exceptions on storage failures.
 * @see <a href="../config/Configuration.html#exceptionsOnNotStorable(boolean)">
 * <code>Configuration#exceptionsOnNotStorable()</code></a>.
 */
public class ObjectNotStorableException extends RuntimeException{
	
	public ObjectNotStorableException(Class a_class){
	    super(Messages.get(a_class.isPrimitive() ? 59: 45, a_class.getName()));
	}
}
