/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

public class BindFileSize {
	
	static final int LENGTH = 10000;
	
	String foo;
	
	public BindFileSize(){
	}
	
	public BindFileSize(int length){
		StringBuffer sb = new StringBuffer(length);
		for (int i = 0; i < length; i++) {
            sb.append("g");
        }  
		this.foo = sb.toString();
	}
	
	public void store(){
		Test.deleteAllInstances(this);
		Test.store(new BindFileSize(LENGTH));
	}
	
	public void testGrowth(){
		int call = 0;
		
		BindFileSize bfs =  (BindFileSize)Test.getOne(this);
		long id = Test.objectContainer().getID(bfs);
		for (int i = 0; i < 12; i++) {
			bfs = new BindFileSize(LENGTH);
			Test.objectContainer().bind(bfs, id);
			Test.objectContainer().set(bfs);
			Test.commit();
			checkFileSize(call++);
			Test.reOpen();
		}
	}
	
	private void checkFileSize(int call){
		if(Test.canCheckFileSize()){
			int newFileLength = Test.fileLength();
			
			// Interesting for manual tests:
			// System.out.println(newFileLength);
			
			if(call == 6){
				// consistency reached, start testing
				jumps = 0;
				fileLength = newFileLength;
			}else if(call > 6){
				if(newFileLength > fileLength){
					if(jumps < 4){
						fileLength = newFileLength;
						jumps ++;
						// allow two further steps in size
						// may be necessary for commit space extension
					}else{
						// now we want constant behaviour
						Test.error();
					}
				}
			}
		}
	}
	
	private static transient int fileLength;
	private static transient int jumps; 



}
