/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import com.db4o.*;
import com.db4o.query.*;


/**
 * 
 */
public class CascadeDeleteFalse {
    
    CascadeDeleteFalseHelper h1;
    CascadeDeleteFalseHelper h2;
    CascadeDeleteFalseHelper h3;
    
    
    public void configure(){
        Db4o.configure().objectClass(this).cascadeOnDelete(true);
        Db4o.configure().objectClass(this).objectField("h3").cascadeOnDelete(false);
    }
    
    public void storeOne(){
        h1 = new CascadeDeleteFalseHelper();
        h2 = new CascadeDeleteFalseHelper();
        h3 = new CascadeDeleteFalseHelper();
    }
    
    public void testOne(){
        checkHelperCount(3);
        Test.delete(this);
        checkHelperCount(1);
        
    }
    
    private void checkHelperCount (int count){
        Query q = Test.query();
        q.constrain(CascadeDeleteFalseHelper.class);
        Test.ensure(q.execute().size() == count);
    }
    
    
    
    public static class CascadeDeleteFalseHelper{
        
    }
}
