/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import com.db4o.*;
import com.db4o.query.*;

public class CascadeOnActivate {
	
	public String name;
	public CascadeOnActivate child;
	
	public void configure(){
		Db4o.configure().objectClass(this).cascadeOnActivate(true);
	}
	
	public void store(){
		name = "1";
		child = new CascadeOnActivate();
		child.name = "2";
		child.child = new CascadeOnActivate();
		child.child.name = "3";
		Test.store(this);
	}
	
	public void test(){
		Query q = Test.query();
		q.constrain(this.getClass());
		q.descend("name").constrain("1");
		ObjectSet os = q.execute();
		CascadeOnActivate coa = (CascadeOnActivate)os.next();
		CascadeOnActivate coa3 = coa.child.child;
		Test.ensure(coa3.name.equals("3"));
		Test.objectContainer().deactivate(coa, Integer.MAX_VALUE);
		Test.ensure(coa3.name == null);
		Test.objectContainer().activate(coa, 1);
		Test.ensure(coa3.name.equals("3"));
	}

}
