/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import com.db4o.ext.*;

/**
 * 
 */
public class DeepSet {
    
    public DeepSet child;
    public String name;
    
    public void storeOne(){
        name = "1";
        child = new DeepSet();
        child.name = "2";
        child.child = new DeepSet();
        child.child.name = "3";
    }
    
    public void test(){
        ExtObjectContainer oc = Test.objectContainer(); 
        name = "1";
        DeepSet ds = (DeepSet)oc.get(this).next();
        ds.name="11";
        ds.child.name = "12";
        oc.set(ds, 2);
        oc.deactivate(ds, Integer.MAX_VALUE);
        name = "11";
        ds = (DeepSet)oc.get(this).next();
        Test.ensure(ds.child.name.equals("12"));
        Test.ensure(ds.child.child.name.equals("3"));
    }

}
