/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import com.db4o.*;
import com.db4o.query.*;

/**
 * 
 */
public class IndexedByIdentity {
    
    Atom atom;
    
    static final int COUNT = 10;
    
    public void configure(){
        Db4o.configure().objectClass(this).objectField("atom").indexed(true);
    }
    
    public void store(){
        for (int i = 0; i < COUNT; i++) {
            IndexedByIdentity ibi = new IndexedByIdentity();
            ibi.atom = new Atom("ibi" + i);
            Test.store(ibi);
        } 
    }
    
    public void test(){
        
        for (int i = 0; i < COUNT; i++) {
            Query q = Test.query();
            q.constrain(Atom.class);
            q.descend("name").constrain("ibi" + i);
            ObjectSet objectSet = q.execute();
            Atom child = (Atom)objectSet.next();
            // child.name = "rnzelbrnft";
            q = Test.query();
            q.constrain(IndexedByIdentity.class);
            q.descend("atom").constrain(child).identity();
            objectSet = q.execute();
            Test.ensure(objectSet.size() == 1);
            IndexedByIdentity ibi = (IndexedByIdentity)objectSet.next();
            Test.ensure(ibi.atom == child);
        }
    }
    
    
    
}
