/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import com.db4o.*;
import com.db4o.query.*;

/**
 * 
 */
public class IndexedUpdatesWithNull {
    
    String str;
    
    public IndexedUpdatesWithNull(){
    }
    
    public IndexedUpdatesWithNull(String str){
        this.str = str;
    }
    
    public void configure(){
        Db4o.configure().objectClass(this).objectField("str").indexed(true);
    }
    
    public void store(){
        Test.store(new IndexedUpdatesWithNull("one"));
        Test.store(new IndexedUpdatesWithNull("two"));
        Test.store(new IndexedUpdatesWithNull("three"));
        Test.store(new IndexedUpdatesWithNull(null));
        Test.store(new IndexedUpdatesWithNull(null));
        Test.store(new IndexedUpdatesWithNull(null));
        Test.store(new IndexedUpdatesWithNull(null));
        Test.store(new IndexedUpdatesWithNull("four"));
    }
    
    public void test(){
        expectNulls(4, true);
        expectNulls(3, false);
        expectNulls(2, false);
        expectNulls(1, true);
    }
    
    private void expectNulls(int count, boolean commit){
        Query q = Test.query();
        q.constrain(this.getClass());
        q.descend("str").constrain(null);
        ObjectSet objectSet = q.execute();
        Test.ensure(objectSet.size() == count);
        IndexedUpdatesWithNull iuwn = (IndexedUpdatesWithNull)objectSet.next();
        iuwn.str = "hi";
        ObjectContainer oc = Test.objectContainer();
        oc.set(iuwn);
        if(commit){
            oc.commit();
        }
    }
}
