/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import com.db4o.*;
import com.db4o.messaging.*;

public class Messaging implements MessageRecipient{
	
	static final String MSG = "hibabe";
	
	private Object lastMessage;
	
	String messageString;
	
	public void test(){
		
		if(Test.isClientServer()){
			
			Test.server().ext().configure().setMessageRecipient(this);
            
			MessageSender sender = Test.objectContainer().configure().getMessageSender();
			this.messageString = MSG; 
			sender.send(this);
			
			synchronized(this) {
			    try {
                    this.wait(5000);
                } catch (InterruptedException e1) {
                    e1.printStackTrace();
                }
			}
			
			Test.ensure(lastMessage instanceof Messaging);
			Messaging received = (Messaging)lastMessage;
			Test.ensure(received.messageString.equals(MSG));
		}
	}

    public void processMessage(ObjectContainer con, Object message) {
		synchronized(this) {
	    	lastMessage = message;
	    	this.notify();
		}
        
    }

}
