/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import java.io.*;

import com.db4o.*;
import com.db4o.query.*;

/**
 * 
 */
public class ParameterizedEvaluation implements Serializable {
    
    public String str;
    
    public void store(){
        store("one");
        store("fun");
        store("ton");
        store("sun");
    }
    
    private void store(String str){
        ParameterizedEvaluation pe = new ParameterizedEvaluation();
        pe.str = str;
        Test.store(pe);
    }
    
    public void test(){
        Test.ensure(queryContains("un").size() == 2);
    }
    
    private ObjectSet queryContains(final String str){
        Query q = Test.query();
        q.constrain(ParameterizedEvaluation.class);
        q.constrain(new Evaluation() {
            public void evaluate(Candidate candidate) {
                ParameterizedEvaluation pe = (ParameterizedEvaluation)candidate.getObject();
                boolean inc = pe.str.indexOf(str) != -1;
                candidate.include(inc);
            }
        });
        
        return q.execute();
    }

}
