/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import com.db4o.*;

public class PersistStaticFieldValues {
    
    static final PsfvHelper ONE = new PsfvHelper();
    static final PsfvHelper TWO = new PsfvHelper();
    static final PsfvHelper THREE = new PsfvHelper();
    
    public PsfvHelper one;
    public PsfvHelper two;
    public PsfvHelper three;
    

    public void configure() {
        Db4o
            .configure()
            .objectClass("com.db4o.test.PersistStaticFieldValues")
            .persistStaticFieldValues();
    }
    
    public void store(){
        Test.deleteAllInstances(this);
        PersistStaticFieldValues psfv = new PersistStaticFieldValues();
        psfv.one = ONE;
        psfv.two = TWO;
        psfv.three = THREE; 
        Test.store(psfv);
    }
    
    public void test(){
        PersistStaticFieldValues psfv = (PersistStaticFieldValues)Test.getOne(this);
        Test.ensure(psfv.one == ONE);
        Test.ensure(psfv.two == TWO);
        Test.ensure(psfv.three == THREE);
    }
    
    public static class PsfvHelper{
        
    }
    

}
