/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test;

import com.db4o.*;
import com.db4o.query.*;

public class QueryNonExistant {
	
	QueryNonExistant1 member;
	
	public QueryNonExistant(){
		// db4o constructor
	}
	
	public QueryNonExistant(boolean createMembers){
		member = new QueryNonExistant1();
		member.member = new QueryNonExistant2();
		member.member.member = this;
		// db4o constructor
	}
	
	public void test(){
		ObjectContainer con = Test.objectContainer(); 
		con.get((new QueryNonExistant(true)));
		Test.ensureOccurrences(new QueryNonExistant(), 0);
		Query q = con.query();
		q.constrain(new QueryNonExistant(true));
		Test.ensure(q.execute().size() == 0);
	}
	
	public static class QueryNonExistant1{
		QueryNonExistant2 member;
	}
	
	public static class QueryNonExistant2 extends QueryNonExistant1{
		QueryNonExistant member;
	}
	
}
