/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test.test2;

import java.util.*;
import com.db4o.test.*;
import com.db4o.test.types.*;
import com.db4o.*;

public class RTreeMapComparator extends RMap{

	TEntry entry(){
		return new IntEntry();
	}

	public Object newInstance(){
		return new TreeMap(new CustomComparator());
	}

	public void specific(ObjectContainer con, int step){
		if(step > 0){
			int foundComparators = 0;
			ObjectSet set = con.get(new TreeMap());
			while(set.hasNext()){
				TreeMap tm = (TreeMap)set.next();
				Comparator cmp = tm.comparator();
				if(cmp != null){
					if(cmp instanceof CustomComparator){
						foundComparators ++;
						if(foundComparators >= step){
							return;
						}
					}
				}
			}
			Regression.addError("RTreeMapComparator comparator lost on the way");
		}
	}
}
