/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test.types;

import com.db4o.*;
import com.db4o.test.*;

public class PrivateConstructor implements RTestable
{
	public String s;

    private PrivateConstructor() {
    }

	public void compare(ObjectContainer con, Object obj, int ver){
		Compare.compare(con, set(newInstance(), ver), obj,"", null);
	}
	
	static public PrivateConstructor construct(){
		return new PrivateConstructor();
	}

	public boolean equals(Object obj){
		if(obj != null){
			if(obj instanceof PrivateConstructor){
				return s.equals(((PrivateConstructor)obj).s);
			}
		} 
		return false;
	}
	
	public boolean jdk2(){
		return true;
	}
	
	public Object newInstance(){
		return new PrivateConstructor();
	}
	
	public Object set(Object obj, int ver){
		((PrivateConstructor)obj).set(ver);
		return obj;
	}
	
	public void set(int ver){
		s = "set" + ver;
	}
	
	public boolean ver3(){
		return false;
	}

}
