/* Copyright (C) 2004   db4objects Inc.   http://www.db4o.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA. */

package com.db4o.test.types;

import com.db4o.*;
import com.db4o.test.*;

import java.util.*;

public class RStack extends RVector{

	public Object newInstance(){
		return new Stack();
	}

	public void specific(ObjectContainer con, int step){
		super.specific(con,step);
		TEntry entry = new TEntry().lastElement();
		Stack stack = new Stack();
		if(step > 0){
			stack.addElement(entry.key);
			ObjectSet set = con.get(stack);
			if(set.size() != step){
				Regression.addError("Stack member query not found");
			}else{
				Stack res = (Stack)set.next();
				if(! (stack.pop().equals(new TEntry().lastElement().key))){
					Regression.addError("Stack order changed.");
				}
			}
		}
	}
}
